#include <windows.h>
#include <stdafx.h>
#include "FineGraphics.h"


static HINSTANCE ghFineGraphicsLibrary=0;

static FINEDLL_PrepareCrop                 FinePrepareCrop;
static FINEDLL_Crop                        FineCrop;
static FINEDLL_CropEx                      FineCropEx;
static FINEDLL_DoneCrop                    FineDoneCrop;
static FINEDLL_PrepareResize               FinePrepareResize;
static FINEDLL_Resize                      FineResize;
static FINEDLL_ResizeEx                    FineResizeEx;
static FINEDLL_DoneResize                  FineDoneResize;
static FINEDLL_FlipVertical                FineFlipVertical;
static FINEDLL_FlipVerticalEx              FineFlipVerticalEx;
static FINEDLL_FlipHorizontal              FineFlipHorizontal;
static FINEDLL_FlipHorizontalEx            FineFlipHorizontalEx;
static FINEDLL_PrepareRotate               FinePrepareRotate;
static FINEDLL_GetRotatedSize              FineGetRotatedSize;
static FINEDLL_Rotate                      FineRotate;
static FINEDLL_RotateEx                    FineRotateEx;
static FINEDLL_DoneRotate                  FineDoneRotate;
static FINEDLL_GetBitmapSize               FineGetBitmapSize;
static FINEDLL_GetRawData                  FineGetRawData;
static FINEDLL_CreateBitmap                FineCreateBitmap;
static FINEDLL_ApplyPalette                FineApplyPalette;
static FINEDLL_LoadBitmap                  FineLoadBitmap;
static FINEDLL_LoadRawImage                FineLoadRawImage;
static FINEDLL_SaveBitmap                  FineSaveBitmap;
static FINEDLL_SaveRawImage                FineSaveRawImage;
static FINEDLL_ConvertFromRGBToRGB         FineConvertFromRGBToRGB;
static FINEDLL_ConvertFromRGB32            FineConvertFromRGB32;
static FINEDLL_ConvertFromRGB32Ex          FineConvertFromRGB32Ex;
static FINEDLL_ConvertToRGB32              FineConvertToRGB32;
static FINEDLL_ConvertToRGB32Ex            FineConvertToRGB32Ex;
static FINEDLL_AddFilter                   FineAddFilter;
static FINEDLL_GetFilterDefaultConfig      FineGetFilterDefaultConfig;
static FINEDLL_ConfigFilter                FineConfigFilter;
static FINEDLL_GetFilterConfig             FineGetFilterConfig;
static FINEDLL_GetFilterGUIDByIndex        FineGetFilterGUIDByIndex;
static FINEDLL_SetFilterOrder              FineSetFilterOrder;
static FINEDLL_FilterImage                 FineFilterImage;
static FINEDLL_RemoveAllFilters            FineRemoveAllFilters;
static FINEDLL_GetUseMMX                   FineGetUseMMX;
static FINEDLL_SetUseMMX                   FineSetUseMMX;
static FINEDLL_GetUseSSE2                  FineGetUseSSE2;
static FINEDLL_SetUseSSE2                  FineSetUseSSE2;

BOOL LoadFineLibrary()
{
  ghFineGraphicsLibrary = LoadLibrary(L"FineGraphics.dll");
  if (ghFineGraphicsLibrary)
  {
	  FinePrepareCrop             = ( FINEDLL_PrepareCrop )             GetProcAddress(ghFineGraphicsLibrary ,"PrepareCrop");
	  FineCrop                    = ( FINEDLL_Crop )                    GetProcAddress(ghFineGraphicsLibrary ,"Crop");
	  FineCropEx                  = ( FINEDLL_CropEx )                  GetProcAddress(ghFineGraphicsLibrary ,"CropEx");
	  FineDoneCrop                = ( FINEDLL_DoneCrop )                GetProcAddress(ghFineGraphicsLibrary ,"DoneCrop");
	  FinePrepareResize           = ( FINEDLL_PrepareResize )           GetProcAddress(ghFineGraphicsLibrary ,"PrepareResize");
	  FineResize                  = ( FINEDLL_Resize )                  GetProcAddress(ghFineGraphicsLibrary ,"Resize");
	  FineResizeEx                = ( FINEDLL_ResizeEx )                GetProcAddress(ghFineGraphicsLibrary ,"ResizeEx");
	  FineDoneResize              = ( FINEDLL_DoneResize )              GetProcAddress(ghFineGraphicsLibrary ,"DoneResize");
	  FineFlipVertical            = ( FINEDLL_FlipVertical )            GetProcAddress(ghFineGraphicsLibrary ,"FlipVertical");
	  FineFlipVerticalEx          = ( FINEDLL_FlipVerticalEx )          GetProcAddress(ghFineGraphicsLibrary ,"FlipVerticalEx");
	  FineFlipHorizontal          = ( FINEDLL_FlipHorizontal )          GetProcAddress(ghFineGraphicsLibrary ,"FlipHorizontal");
	  FineFlipHorizontalEx        = ( FINEDLL_FlipHorizontalEx )        GetProcAddress(ghFineGraphicsLibrary ,"FlipHorizontalEx");
	  FinePrepareRotate           = ( FINEDLL_PrepareRotate )           GetProcAddress(ghFineGraphicsLibrary ,"PrepareRotate");
	  FineGetRotatedSize          = ( FINEDLL_GetRotatedSize )          GetProcAddress(ghFineGraphicsLibrary ,"GetRotatedSize");
	  FineRotate                  = ( FINEDLL_Rotate )                  GetProcAddress(ghFineGraphicsLibrary ,"Rotate");
	  FineRotateEx                = ( FINEDLL_RotateEx )                GetProcAddress(ghFineGraphicsLibrary ,"RotateEx");
	  FineDoneRotate              = ( FINEDLL_DoneRotate )              GetProcAddress(ghFineGraphicsLibrary ,"DoneRotate");
	  FineGetBitmapSize           = ( FINEDLL_GetBitmapSize )           GetProcAddress(ghFineGraphicsLibrary ,"GetBitmapSize");
	  FineGetRawData              = ( FINEDLL_GetRawData )              GetProcAddress(ghFineGraphicsLibrary ,"GetRawData");
	  FineCreateBitmap            = ( FINEDLL_CreateBitmap )            GetProcAddress(ghFineGraphicsLibrary ,"CreateBitmap");
	  FineApplyPalette            = ( FINEDLL_ApplyPalette )            GetProcAddress(ghFineGraphicsLibrary ,"ApplyPalette");
	  FineLoadBitmap              = ( FINEDLL_LoadBitmap )              GetProcAddress(ghFineGraphicsLibrary ,"LoadBitmap");
	  FineLoadRawImage            = ( FINEDLL_LoadRawImage )            GetProcAddress(ghFineGraphicsLibrary ,"LoadRawImage");
	  FineSaveBitmap              = ( FINEDLL_SaveBitmap )              GetProcAddress(ghFineGraphicsLibrary ,"SaveBitmap");
	  FineSaveRawImage            = ( FINEDLL_SaveRawImage )            GetProcAddress(ghFineGraphicsLibrary ,"SaveRawImage");
	  FineConvertFromRGBToRGB     = ( FINEDLL_ConvertFromRGBToRGB )     GetProcAddress(ghFineGraphicsLibrary ,"ConvertFromRGBToRGB");
	  FineConvertFromRGB32        = ( FINEDLL_ConvertFromRGB32 )        GetProcAddress(ghFineGraphicsLibrary ,"ConvertFromRGB32");
	  FineConvertFromRGB32Ex      = ( FINEDLL_ConvertFromRGB32Ex )      GetProcAddress(ghFineGraphicsLibrary ,"ConvertFromRGB32Ex");
	  FineConvertToRGB32          = ( FINEDLL_ConvertToRGB32 )          GetProcAddress(ghFineGraphicsLibrary ,"ConvertToRGB32");
	  FineConvertToRGB32Ex        = ( FINEDLL_ConvertToRGB32Ex )        GetProcAddress(ghFineGraphicsLibrary ,"ConvertToRGB32Ex");
	  FineAddFilter               = ( FINEDLL_AddFilter )               GetProcAddress(ghFineGraphicsLibrary ,"AddFilter");
	  FineGetFilterDefaultConfig  = ( FINEDLL_GetFilterDefaultConfig )  GetProcAddress(ghFineGraphicsLibrary ,"GetFilterDefaultConfig");
	  FineConfigFilter            = ( FINEDLL_ConfigFilter )            GetProcAddress(ghFineGraphicsLibrary ,"ConfigFilter");
	  FineGetFilterConfig         = ( FINEDLL_GetFilterConfig )         GetProcAddress(ghFineGraphicsLibrary ,"GetFilterConfig");
	  FineGetFilterGUIDByIndex    = ( FINEDLL_GetFilterGUIDByIndex )    GetProcAddress(ghFineGraphicsLibrary ,"GetFilterGUIDByIndex");
	  FineSetFilterOrder          = ( FINEDLL_SetFilterOrder )          GetProcAddress(ghFineGraphicsLibrary ,"SetFilterOrder");
	  FineFilterImage             = ( FINEDLL_FilterImage )             GetProcAddress(ghFineGraphicsLibrary ,"FilterImage");
	  FineRemoveAllFilters        = ( FINEDLL_RemoveAllFilters )        GetProcAddress(ghFineGraphicsLibrary ,"RemoveAllFilters");
	  FineGetUseMMX               = ( FINEDLL_GetUseMMX )               GetProcAddress(ghFineGraphicsLibrary ,"GetUseMMX");
	  FineSetUseMMX               = ( FINEDLL_SetUseMMX )               GetProcAddress(ghFineGraphicsLibrary ,"SetUseMMX");
	  FineGetUseSSE2              = ( FINEDLL_GetUseSSE2 )              GetProcAddress(ghFineGraphicsLibrary ,"GetUseSSE2");
	  FineSetUseSSE2              = ( FINEDLL_SetUseSSE2 )              GetProcAddress(ghFineGraphicsLibrary ,"SetUseSSE2");
  }
  return (ghFineGraphicsLibrary)? TRUE : FALSE;
}

VOID FreeFineLibrary()
{
  FreeLibrary( ghFineGraphicsLibrary );
  ghFineGraphicsLibrary = 0;
}

BOOL    FINEAPI Crop(HBITMAP Bitmap)
{
	return FineCrop(Bitmap);
}

BOOL    FINEAPI CropEx(HBITMAP SrcBitmap, HBITMAP* DstBitmap)
{
	return FineCropEx(SrcBitmap, DstBitmap);
}

BOOL    FINEAPI DoneCrop()
{
	return FineDoneCrop();
}

BOOL    FINEAPI PrepareResize(LONG SrcWidth, LONG SrcHeight, RECT SrcRect, RECT DstRect, LONG ResizeMethod)
{
	return FinePrepareResize(SrcWidth, SrcHeight, SrcRect, DstRect, ResizeMethod);
}

BOOL    FINEAPI Resize(HBITMAP* Bitmap)
{
	return FineResize(Bitmap);
}

BOOL    FINEAPI ResizeEx(HBITMAP SrcBitmap, HBITMAP* DstBitmap)
{
	return FineResizeEx(SrcBitmap,DstBitmap);
}

BOOL    FINEAPI DoneResize()
{
	return FineDoneResize();
}

BOOL    FINEAPI FlipVertical(HBITMAP* Bitmap)
{
	return FineFlipVertical(Bitmap);
}

BOOL    FINEAPI FlipVerticalEx(HBITMAP SrcBitmap, HBITMAP* DstBitmap)
{
	return FineFlipVerticalEx(SrcBitmap,DstBitmap);
}

BOOL    FINEAPI FlipHorizontal(HBITMAP* Bitmap)
{
	return FineFlipHorizontal(Bitmap);
}

BOOL    FINEAPI FlipHorizontalEx(HBITMAP SrcBitmap, HBITMAP* DstBitmap)
{
	return FineFlipHorizontalEx(SrcBitmap,DstBitmap);
}

BOOL    FINEAPI PrepareRotate(LONG ImageWidth, LONG ImageHeight, double RotationAngle, POINT RotationCenter, LONG RotationMethod, LONG RotationType)
{
	return FinePrepareRotate(ImageWidth,ImageHeight,RotationAngle,RotationCenter,RotationMethod,RotationType);
}

SIZE    FINEAPI GetRotatedSize()
{
	return FineGetRotatedSize();
}

BOOL    FINEAPI Rotate(HBITMAP* Bitmap, ULONG GapColor)
{
	return FineRotate(Bitmap,GapColor);
}

BOOL    FINEAPI RotateEx(HBITMAP SrcBitmap, HBITMAP* DstBitmap, ULONG GapColor)
{
	return FineRotateEx(SrcBitmap,DstBitmap,GapColor);
}

BOOL    FINEAPI DoneRotate()
{
	return FineDoneRotate();
}

LONG	  FINEAPI GetBitmapSize(LONG ImageWidth, LONG ImageHeight, GUID* MediaSubtype)
{
	return FineGetBitmapSize(ImageWidth,ImageHeight,MediaSubtype);
}

BOOL    FINEAPI GetRawData(HBITMAP Bitmap, BYTE* RawData, GUID* MediaSubtype)
{
	return FineGetRawData(Bitmap,RawData,MediaSubtype);
}

HBITMAP FINEAPI CreateBitmap(LONG ImageWidth, LONG ImageHeight, GUID* MediaSubtype)
{
	return FineCreateBitmap(ImageWidth,ImageHeight,MediaSubtype);
}

BOOL    FINEAPI ApplyPalette(HBITMAP Bitmap, HPALETTE Palette)
{
	return FineApplyPalette(Bitmap,Palette);
}

HBITMAP FINEAPI LoadBitmap(LPWSTR  FileName, GUID* OutputMediaSubtype, LONG OutputQuantizationType, LONG OutputDitherType)
{
	return FineLoadBitmap(FileName,OutputMediaSubtype,OutputQuantizationType,OutputDitherType);
}

HBITMAP FINEAPI LoadRawImage(LPWSTR  FileName, LONG ImageWidth, LONG ImageHeight, GUID* InputMediaSubtype, GUID* OutputMediaSubtype, LONG OutputQuantizationType, LONG OutputDitherType)
{
	return FineLoadRawImage(FileName,ImageWidth,ImageHeight,InputMediaSubtype,OutputMediaSubtype,OutputQuantizationType,OutputDitherType);
}

BOOL    FINEAPI SaveBitmap(LPWSTR  FileName, HBITMAP Bitmap, GUID* MediaSubtype)
{
	return FineSaveBitmap(FileName,Bitmap,MediaSubtype);
}

BOOL    FINEAPI SaveRawImage(LPWSTR  FileName, HBITMAP Bitmap, GUID* MediaSubtype)
{
	return FineSaveRawImage(FileName,Bitmap,MediaSubtype);
}

BOOL    FINEAPI ConvertFromRGBToRGB(HBITMAP SrcBitmap, HBITMAP* DstBitmap, LONG QuantizationType, LONG DitherType)
{
	return FineConvertFromRGBToRGB(SrcBitmap,DstBitmap,QuantizationType,DitherType);
}

BOOL    FINEAPI ConvertFromRGB32(BYTE*   SrcImage, BYTE* DstImage, HPALETTE* DstPalette, LONG ImageWidth, LONG ImageHeight, GUID* MediaSubtype, LONG QuantizationType, LONG DitherType)
{
	return FineConvertFromRGB32(SrcImage,DstImage,DstPalette,ImageWidth,ImageHeight,MediaSubtype, QuantizationType, DitherType);
}

BOOL    FINEAPI ConvertFromRGB32Ex(HBITMAP SrcBitmap, HBITMAP* DstBitmap, GUID* MediaSubtype, LONG QuantizationType, LONG DitherType)
{
	return FineConvertFromRGB32Ex(SrcBitmap,DstBitmap,MediaSubtype,QuantizationType,DitherType);
}

BOOL    FINEAPI ConvertToRGB32(BYTE*   SrcImage, BYTE* DstImage, HPALETTE SrcPalette, LONG ImageWidth, LONG ImageHeight, GUID* MediaSubtype)
{
	return FineConvertToRGB32(SrcImage,DstImage,SrcPalette,ImageWidth,ImageHeight,MediaSubtype);
}

BOOL    FINEAPI ConvertToRGB32Ex(HBITMAP SrcBitmap, HBITMAP* DstBitmap, GUID* MediaSubtype)
{
	return FineConvertToRGB32Ex(SrcBitmap,DstBitmap,MediaSubtype);
}

HRESULT FINEAPI AddFilter(GUID* FilterGUID, FILTER_PARAMETERS* FilterParameters, LONG* Index)
{
	return FineAddFilter(FilterGUID,FilterParameters,Index);
}

HRESULT FINEAPI GetFilterDefaultConfig (GUID* FilterGUID, FILTER_PARAMETERS* FilterParameters)
{
	return FineGetFilterDefaultConfig(FilterGUID,FilterParameters);
}

HRESULT FINEAPI ConfigFilter(LONG Index, BOOL Active, FILTER_PARAMETERS* FilterParameters)
{
	return FineConfigFilter(Index,Active,FilterParameters);
}

HRESULT FINEAPI GetFilterConfig(LONG Index, BOOL* Active, FILTER_PARAMETERS* FilterParameters)
{
	return FineGetFilterConfig(Index,Active,FilterParameters);
}

HRESULT FINEAPI GetFilterGUIDByIndex(LONG Index, GUID* FilterGUID)
{
	return FineGetFilterGUIDByIndex(Index,FilterGUID);
}

HRESULT FINEAPI SetFilterOrder(LONG Index, LONG Order)
{
	return FineSetFilterOrder(Index, Order);
}

BOOL    FINEAPI FilterImage(HBITMAP* Bitmap)
{
	return FineFilterImage(Bitmap);
}

HRESULT FINEAPI RemoveAllFilters()
{
	return FineRemoveAllFilters();
}
BOOL    FINEAPI GetUseMMX()
{
	return FineGetUseMMX();
}

HRESULT FINEAPI SetUseMMX (BOOL UseMMX)
{
	return FineSetUseMMX(UseMMX);
}

BOOL    FINEAPI GetUseSSE2()
{
	return FineGetUseSSE2();
}

HRESULT FINEAPI SetUseSSE2(BOOL UseSSE2)
{
	return FineSetUseSSE2(UseSSE2);
}