//********************************************************************************
//                               FineGraphics Header File
// Note: When Using GetProcAddress the name of the function is same as prototype
//       exept the "FINEDLL_" prefix. For example for FINEDLL_PrepareCrop use
//       GetProcAddress(hLIB ,"PrepareCrop"); 
//
//*******************************************************************************
#include <initguid.h>
#define FINEAPI _stdcall 

#define QuantizationType_Nearest              0
#define QuantizationType_Halftone             1
#define QuantizationType_DitheredNearest      2
#define QuantizationType_DitheredHalftone     3
#define QuantizationType_FastDitheredNearest  4
#define QuantizationType_FastDitheredHalftone 5

#define DitheringType_None                    0
#define DitheringType_Ordered                 1
#define DitheringType_FloydSteinberg          2

#define Resample_Fast                         0
#define Resample_FastLinear                   1
#define Resample_Nearest                      2
#define Resample_Linear                       3
#define Resample_Spline                       4
#define Resample_Hermite                      5
#define Resample_Bell                         6
#define Resample_Cosine                       7
#define Resample_Cubic                        8
#define Resample_Gaussian                     9
#define Resample_Blackman                     10
#define Resample_Hann                         11
#define Resample_Hamming                      12
#define Resample_Sinsh                        13
#define Resample_Quadratic                    14
#define Resample_QuadraticBSpline             15
#define Resample_CubicConvolution             16
#define Resample_CatmullRom                   17
#define Resample_Mitchell                     18
#define Resample_Lanczos                      19
#define Resample_Lanczos3                     20
#define Resample_Lanczos8                     21
#define Resample_DirectDrawVideo              22
#define Resample_DirectDrawSystem             23
#define Resample_GDIPlus_Default              24
#define Resample_GDIPlus_LowQuality           25
#define Resample_GDIPlus_HighQuality          26
#define Resample_GDIPlus_Bilinear             27
#define Resample_GDIPlus_Bicubic              28
#define Resample_GDIPlus_NearestNeighbor      29
#define Resample_GDIPlus_HighQualityBilinear  30
#define Resample_GDIPlus_HighQualityBicubic   31
#define Resample_GDI                          32

#define RotationType_Crop                           0
#define RotationType_Resize                         1
#define RotationMethod_Fast                         0
#define RotationMethod_FastBilinear                 1
#define RotationMethod_GDIPlus_Default              2
#define RotationMethod_GDIPlus_LowQuality           3
#define RotationMethod_GDIPlus_HighQuality          4
#define RotationMethod_GDIPlus_Bilinear             5
#define RotationMethod_GDIPlus_Bicubic              6
#define RotationMethod_GDIPlus_NearestNeighbor      7
#define RotationMethod_GDIPlus_HighQualityBilinear  8
#define RotationMethod_GDIPlus_HighQualityBicubic   9
#define RotationMethod_GDI                          10


typedef struct tagFILTER_PARAMETERS{
        LONG   LParams[50];
        double DParams[50];
}FILTER_PARAMETERS;

  DEFINE_GUID(MEDIASUBTYPE_ANY        , 0x00000000,  0x0000,  0x0000,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
  DEFINE_GUID(MEDIASUBTYPE_RGB1	      , 0xE436EB78,  0x524F,  0x11CE,  0x9F,0x53,0x00,0x20,0xAF,0x0B,0xA7,0x70);
  DEFINE_GUID(MEDIASUBTYPE_RGB4       , 0xE436EB79,  0x524F,  0x11CE,  0x9F,0x53,0x00,0x20,0xAF,0x0B,0xA7,0x70);
  DEFINE_GUID(MEDIASUBTYPE_RGB8       , 0xE436EB7A,  0x524F,  0x11CE,  0x9F,0x53,0x00,0x20,0xAF,0x0B,0xA7,0x70);
  DEFINE_GUID(MEDIASUBTYPE_RGB565     , 0xE436EB7B,  0x524F,  0x11CE,  0x9F,0x53,0x00,0x20,0xAF,0x0B,0xA7,0x70);
  DEFINE_GUID(MEDIASUBTYPE_RGB555     , 0xE436EB7C,  0x524F,  0x11CE,  0x9F,0x53,0x00,0x20,0xAF,0x0B,0xA7,0x70);
  DEFINE_GUID(MEDIASUBTYPE_RGB24      , 0xE436EB7D,  0x524F,  0x11CE,  0x9F,0x53,0x00,0x20,0xAF,0x0B,0xA7,0x70);
  DEFINE_GUID(MEDIASUBTYPE_RGB32      , 0xE436EB7E,  0x524F,  0x11CE,  0x9F,0x53,0x00,0x20,0xAF,0x0B,0xA7,0x70);
  DEFINE_GUID(MEDIASUBTYPE_ARGB32     , 0x773c9ac0,  0x3274,  0x11d0,  0xb7,0x24,0x00,0xaa,0x00,0x6c,0x1a,0x01);
  DEFINE_GUID(MEDIASUBTYPE_UYVY       , 0x59565955,  0x0000,  0x0010,  0x80,0x00,0x00,0xAA,0x00,0x38,0x9B,0x71);
  DEFINE_GUID(MEDIASUBTYPE_YUY2       , 0x32595559,  0x0000,  0x0010,  0x80,0x00,0x00,0xAA,0x00,0x38,0x9B,0x71);
  DEFINE_GUID(MEDIASUBTYPE_YVYU       , 0x55595659,  0x0000,  0x0010,  0x80,0x00,0x00,0xAA,0x00,0x38,0x9B,0x71);
  DEFINE_GUID(MEDIASUBTYPE_YV12       , 0x32315659,  0x0000,  0x0010,  0x80,0x00,0x00,0xAA,0x00,0x38,0x9B,0x71);
  DEFINE_GUID(MEDIASUBTYPE_IYUV       , 0x56555949,  0x0000,  0x0010,  0x80,0x00,0x00,0xaa,0x00,0x38,0x9b,0x71);
  DEFINE_GUID(MEDIASUBTYPE_NV12       , 0x3231564E,  0x0000,  0x0010,  0x80,0x00,0x00,0xAA,0x00,0x38,0x9B,0x71);

  DEFINE_GUID(Filter_GUID_Brightness  , 0xF3D3B87C,  0xD34E,  0x45F3,  0x86,0xA1,0x2C,0x2C,0x8B,0x8D,0x22,0x47);
  DEFINE_GUID(Filter_GUID_Contrast    , 0xB76096C6,  0x3A9A,  0x4086,  0xA9,0xA4,0x2E,0x9F,0x6A,0xC2,0x45,0xDF);
  DEFINE_GUID(Filter_GUID_Lightness   , 0x2E6A1E18,  0x5717,  0x49FE,  0xA6,0x59,0x00,0xF1,0xB7,0x54,0x00,0x2C);
  DEFINE_GUID(Filter_GUID_Darkness    , 0x41BCDD15,  0x59BC,  0x435C,  0x90,0x4B,0xBF,0x27,0x15,0xC7,0x78,0xA6);
  DEFINE_GUID(Filter_GUID_Gamma       , 0x1E31BC62,  0x34A5,  0x491A,  0xAA,0x70,0x51,0x1A,0xA1,0x29,0xB1,0x3C);
  DEFINE_GUID(Filter_GUID_Saturation  , 0x2FDCF325,  0xE1E3,  0x4DCC,  0x8C,0xBF,0x04,0xBF,0x17,0x92,0x7D,0x79);
  DEFINE_GUID(Filter_GUID_Posterize   , 0xF3BB76E3,  0x0115,  0x4093,  0x9B,0xBB,0xD5,0x5E,0x91,0x00,0x17,0xF9);
  DEFINE_GUID(Filter_GUID_Solorize    , 0xF2176176,  0x1ED6,  0x4160,  0xB9,0x30,0x3A,0x47,0x25,0x56,0x43,0x58);
  DEFINE_GUID(Filter_GUID_RemoveRed   , 0x9B85F390,  0xED43,  0x4E2F,  0x88,0x09,0xA7,0xD1,0x68,0x20,0xBF,0x4F);
  DEFINE_GUID(Filter_GUID_RemoveGreen , 0xF8A8533C,  0x0EC8,  0x41B2,  0xA7,0x13,0x35,0x29,0x17,0xDE,0x93,0x4B);
  DEFINE_GUID(Filter_GUID_RemoveBlue  , 0xB352B2E4,  0x754A,  0x4252,  0x98,0xF0,0x78,0xA2,0x78,0xDA,0x0C,0x10);
  DEFINE_GUID(Filter_GUID_AndMask     , 0x6B30D6FD,  0x3894,  0x4DDA,  0x88,0x40,0x48,0x96,0x5A,0xA8,0x72,0xF0);
  DEFINE_GUID(Filter_GUID_OrMask      , 0xEA2AE8D9,  0x583D,  0x487F,  0xAD,0x58,0xAB,0xE8,0xEF,0x4A,0xCE,0x75);
  DEFINE_GUID(Filter_GUID_XorMask     , 0x4A696F43,  0x1E1A,  0x4AF8,  0xBC,0xF8,0x9C,0x5C,0xFB,0x0A,0xFD,0x3F);
  DEFINE_GUID(Filter_GUID_Negative    , 0xCB1C6BBD,  0xBB86,  0x4C74,  0x8E,0x45,0x92,0xC9,0x97,0xCA,0x54,0x98);
  DEFINE_GUID(Filter_GUID_GrayScale   , 0xBBA19AC4,  0xB62B,  0x466B,  0x97,0x27,0xAD,0x69,0x6F,0x71,0x1B,0x2E);
  DEFINE_GUID(Filter_GUID_Sepia       , 0xB9AACA34,  0xB61F,  0x4EFD,  0xB1,0x24,0x0C,0xA6,0xE8,0xD3,0xB9,0x1C);
  DEFINE_GUID(Filter_GUID_SepiaStrong , 0xE333C765,  0x9AED,  0x4A93,  0xB2,0x82,0x09,0x24,0xF0,0x63,0xDE,0x80);
  DEFINE_GUID(Filter_GUID_Threshold   , 0x064DE447,  0x1973,  0x4F84,  0x89,0xE4,0x72,0xBB,0x95,0x02,0xC2,0xE4);
  DEFINE_GUID(Filter_GUID_SplitLight  , 0x6F317C43,  0x1371,  0x4256,  0xBD,0x44,0x39,0x61,0xB6,0xAB,0xA9,0xED);
  DEFINE_GUID(Filter_GUID_AntiAlias   , 0xB4ABF202,  0x888C,  0x4FB9,  0x8D,0x30,0x6D,0x20,0x35,0x8E,0x51,0x95);
  DEFINE_GUID(Filter_GUID_SplitBlur   , 0x5284375A,  0xE9DE,  0x43F6,  0x83,0x95,0x34,0xC8,0x57,0xA6,0xD3,0xBD);
  DEFINE_GUID(Filter_GUID_GausianBlur , 0x95E3B1FF,  0x92E3,  0x4F94,  0x92,0x2B,0x7D,0x99,0xDC,0x89,0x45,0x49);
  DEFINE_GUID(Filter_GUID_MonoNoise   , 0xC20E7629,  0x12C3,  0x4E49,  0xB1,0xD5,0x2A,0x5E,0xA7,0xDE,0xB6,0xBF);
  DEFINE_GUID(Filter_GUID_ColorNoise  , 0x6B2AF958,  0x7EF0,  0x41B1,  0x91,0xB8,0xE0,0x79,0xF2,0xFA,0x7F,0x88);
  DEFINE_GUID(Filter_GUID_Emboss      , 0x2EE2E4BA,  0xCCEE,  0x415E,  0x9F,0x8E,0xE9,0xCA,0x62,0xC1,0x63,0xE1);
  DEFINE_GUID(Filter_GUID_Pixelate    , 0x2C35B6F2,  0x3F07,  0x426D,  0x97,0x13,0x00,0x97,0x5C,0xD7,0xB8,0x51);
  DEFINE_GUID(Filter_GUID_Cell        , 0xEFAFD33F,  0x8D6C,  0x4798,  0x9B,0xFA,0xAC,0xC3,0xA4,0x8C,0x41,0x5E);
  DEFINE_GUID(Filter_GUID_Tile        , 0x1B7CC785,  0xAA78,  0x4901,  0xB6,0x27,0x94,0x13,0x31,0x86,0xFE,0x3A);

  typedef BOOL    (FINEAPI* FINEDLL_PrepareCrop)            (LONG OriginalWidth, LONG OriginalHeight, LONG Left, LONG Top, LONG Right, LONG Bottom); 
  typedef BOOL    (FINEAPI* FINEDLL_Crop)                   (HBITMAP Bitmap); 
  typedef BOOL    (FINEAPI* FINEDLL_CropEx)                 (HBITMAP SrcBitmap, HBITMAP* DstBitmap);
  typedef BOOL    (FINEAPI* FINEDLL_DoneCrop)               ();
  typedef BOOL    (FINEAPI* FINEDLL_PrepareResize)          (LONG SrcWidth, LONG SrcHeight, RECT SrcRect, RECT DstRect, LONG ResizeMethod); 
  typedef BOOL    (FINEAPI* FINEDLL_Resize)                 (HBITMAP* Bitmap);
  typedef BOOL    (FINEAPI* FINEDLL_ResizeEx)               (HBITMAP SrcBitmap, HBITMAP* DstBitmap);
  typedef BOOL    (FINEAPI* FINEDLL_DoneResize)             ();
  typedef BOOL    (FINEAPI* FINEDLL_FlipVertical)           (HBITMAP* Bitmap);
  typedef BOOL    (FINEAPI* FINEDLL_FlipVerticalEx)         (HBITMAP SrcBitmap, HBITMAP* DstBitmap);
  typedef BOOL    (FINEAPI* FINEDLL_FlipHorizontal)         (HBITMAP* Bitmap);
  typedef BOOL    (FINEAPI* FINEDLL_FlipHorizontalEx)       (HBITMAP SrcBitmap, HBITMAP* DstBitmap);
  typedef BOOL    (FINEAPI* FINEDLL_PrepareRotate)          (LONG ImageWidth, LONG ImageHeight, double RotationAngle, POINT RotationCenter, LONG RotationMethod, LONG RotationType); 
  typedef SIZE    (FINEAPI* FINEDLL_GetRotatedSize)         ();
  typedef BOOL    (FINEAPI* FINEDLL_Rotate)                 (HBITMAP* Bitmap, ULONG GapColor);
  typedef BOOL    (FINEAPI* FINEDLL_RotateEx)               (HBITMAP SrcBitmap, HBITMAP* DstBitmap, ULONG GapColor);
  typedef BOOL    (FINEAPI* FINEDLL_DoneRotate)             ();
  typedef LONG	  (FINEAPI* FINEDLL_GetBitmapSize)          (LONG    ImageWidth, LONG ImageHeight, GUID* MediaSubtype);
  typedef BOOL    (FINEAPI* FINEDLL_GetRawData)             (HBITMAP Bitmap, BYTE* RawData, GUID* MediaSubtype);
  typedef HBITMAP (FINEAPI* FINEDLL_CreateBitmap)           (LONG    ImageWidth, LONG ImageHeight, GUID* MediaSubtype);
  typedef BOOL    (FINEAPI* FINEDLL_ApplyPalette)           (HBITMAP Bitmap, HPALETTE Palette); 
  typedef HBITMAP (FINEAPI* FINEDLL_LoadBitmap)             (LPWSTR  FileName, GUID* OutputMediaSubtype, LONG OutputQuantizationType, LONG OutputDitherType);  
  typedef HBITMAP (FINEAPI* FINEDLL_LoadRawImage)           (LPWSTR  FileName, LONG ImageWidth, LONG ImageHeight, GUID* InputMediaSubtype, GUID* OutputMediaSubtype, LONG OutputQuantizationType, LONG OutputDitherType);
  typedef BOOL    (FINEAPI* FINEDLL_SaveBitmap)             (LPWSTR  FileName, HBITMAP Bitmap, GUID* MediaSubtype);
  typedef BOOL    (FINEAPI* FINEDLL_SaveRawImage)           (LPWSTR  FileName, HBITMAP Bitmap, GUID* MediaSubtype);
  typedef BOOL    (FINEAPI* FINEDLL_ConvertFromRGBToRGB)    (HBITMAP SrcBitmap, HBITMAP* DstBitmap, LONG QuantizationType, LONG DitherType);
  typedef BOOL    (FINEAPI* FINEDLL_ConvertFromRGB32)       (BYTE*   SrcImage, BYTE* DstImage, HPALETTE* DstPalette, LONG ImageWidth, LONG ImageHeight, GUID* MediaSubtype, LONG QuantizationType, LONG DitherType);
  typedef BOOL    (FINEAPI* FINEDLL_ConvertFromRGB32Ex)     (HBITMAP SrcBitmap, HBITMAP* DstBitmap, GUID* MediaSubtype, LONG QuantizationType, LONG DitherType);
  typedef BOOL    (FINEAPI* FINEDLL_ConvertToRGB32)         (BYTE*   SrcImage, BYTE* DstImage, HPALETTE SrcPalette, LONG ImageWidth, LONG ImageHeight, GUID* MediaSubtype);
  typedef BOOL    (FINEAPI* FINEDLL_ConvertToRGB32Ex)       (HBITMAP SrcBitmap, HBITMAP* DstBitmap, GUID* MediaSubtype);
  typedef HRESULT (FINEAPI* FINEDLL_AddFilter)              (GUID* FilterGUID, FILTER_PARAMETERS* FilterParameters, LONG* Index); 
  typedef HRESULT (FINEAPI* FINEDLL_GetFilterDefaultConfig) (GUID* FilterGUID, FILTER_PARAMETERS* FilterParameters); 
  typedef HRESULT (FINEAPI* FINEDLL_ConfigFilter)           (LONG Index, BOOL Active, FILTER_PARAMETERS* FilterParameters); 
  typedef HRESULT (FINEAPI* FINEDLL_GetFilterConfig)        (LONG Index, BOOL* Active, FILTER_PARAMETERS* FilterParameters);
  typedef HRESULT (FINEAPI* FINEDLL_GetFilterGUIDByIndex)   (LONG Index, GUID* FilterGUID);
  typedef HRESULT (FINEAPI* FINEDLL_SetFilterOrder)         (LONG Index, LONG Order);
  typedef BOOL    (FINEAPI* FINEDLL_FilterImage)            (HBITMAP* Bitmap);
  typedef HRESULT (FINEAPI* FINEDLL_RemoveAllFilters)       ();
  typedef BOOL    (FINEAPI* FINEDLL_GetUseMMX)              ();
  typedef HRESULT (FINEAPI* FINEDLL_SetUseMMX)              (BOOL UseMMX);
  typedef BOOL    (FINEAPI* FINEDLL_GetUseSSE2)             ();
  typedef HRESULT (FINEAPI* FINEDLL_SetUseSSE2)             (BOOL UseSSE2);  

  BOOL    LoadFineLibrary                ();
  VOID    FreeFineLibrary                ();
  BOOL    FINEAPI PrepareCrop            (LONG OriginalWidth, LONG OriginalHeight, LONG Left, LONG Top, LONG Right, LONG Bottom);
  BOOL    FINEAPI Crop                   (HBITMAP Bitmap);
  BOOL    FINEAPI CropEx                 (HBITMAP SrcBitmap, HBITMAP* DstBitmap);
  BOOL    FINEAPI DoneCrop               ();
  BOOL    FINEAPI PrepareResize          (LONG SrcWidth, LONG SrcHeight, RECT SrcRect, RECT DstRect, LONG ResizeMethod);
  BOOL    FINEAPI Resize                 (HBITMAP* Bitmap);
  BOOL    FINEAPI ResizeEx               (HBITMAP SrcBitmap, HBITMAP* DstBitmap);
  BOOL    FINEAPI DoneResize             ();
  BOOL    FINEAPI FlipVertical           (HBITMAP* Bitmap);
  BOOL    FINEAPI FlipVerticalEx         (HBITMAP SrcBitmap, HBITMAP* DstBitmap);
  BOOL    FINEAPI FlipHorizontal         (HBITMAP* Bitmap);
  BOOL    FINEAPI FlipHorizontalEx       (HBITMAP SrcBitmap, HBITMAP* DstBitmap);
  BOOL    FINEAPI PrepareRotate          (LONG ImageWidth, LONG ImageHeight, double RotationAngle, POINT RotationCenter, LONG RotationMethod, LONG RotationType);
  SIZE    FINEAPI GetRotatedSize         ();
  BOOL    FINEAPI Rotate                 (HBITMAP* Bitmap, ULONG GapColor);
  BOOL    FINEAPI RotateEx               (HBITMAP SrcBitmap, HBITMAP* DstBitmap, ULONG GapColor);
  BOOL    FINEAPI DoneRotate             ();
  LONG	  FINEAPI GetBitmapSize          (LONG    ImageWidth, LONG ImageHeight, GUID* MediaSubtype);
  BOOL    FINEAPI GetRawData             (HBITMAP Bitmap, BYTE* RawData, GUID* MediaSubtype);
  HBITMAP FINEAPI CreateBitmap           (LONG    ImageWidth, LONG ImageHeight, GUID* MediaSubtype);
  BOOL    FINEAPI ApplyPalette           (HBITMAP Bitmap, HPALETTE Palette); 
  HBITMAP FINEAPI LoadBitmap             (LPWSTR  FileName, GUID* OutputMediaSubtype, LONG OutputQuantizationType, LONG OutputDitherType);
  HBITMAP FINEAPI LoadRawImage           (LPWSTR  FileName, LONG ImageWidth, LONG ImageHeight, GUID* InputMediaSubtype, GUID* OutputMediaSubtype, LONG OutputQuantizationType, LONG OutputDitherType);
  BOOL    FINEAPI SaveBitmap             (LPWSTR  FileName, HBITMAP Bitmap, GUID* MediaSubtype);
  BOOL    FINEAPI SaveRawImage           (LPWSTR  FileName, HBITMAP Bitmap, GUID* MediaSubtype);
  BOOL    FINEAPI ConvertFromRGBToRGB    (HBITMAP SrcBitmap, HBITMAP* DstBitmap, LONG QuantizationType, LONG DitherType);
  BOOL    FINEAPI ConvertFromRGB32       (BYTE*   SrcImage, BYTE* DstImage, HPALETTE* DstPalette, LONG ImageWidth, LONG ImageHeight, GUID* MediaSubtype, LONG QuantizationType, LONG DitherType);
  BOOL    FINEAPI ConvertFromRGB32Ex     (HBITMAP SrcBitmap, HBITMAP* DstBitmap, GUID* MediaSubtype, LONG QuantizationType, LONG DitherType);
  BOOL    FINEAPI ConvertToRGB32         (BYTE*   SrcImage, BYTE* DstImage, HPALETTE SrcPalette, LONG ImageWidth, LONG ImageHeight, GUID* MediaSubtype);
  BOOL    FINEAPI ConvertToRGB32Ex       (HBITMAP SrcBitmap, HBITMAP* DstBitmap, GUID* MediaSubtype);
  HRESULT FINEAPI AddFilter              (GUID* FilterGUID, FILTER_PARAMETERS* FilterParameters, LONG* Index);
  HRESULT FINEAPI GetFilterDefaultConfig (GUID* FilterGUID, FILTER_PARAMETERS* FilterParameters);
  HRESULT FINEAPI ConfigFilter           (LONG Index, BOOL Active, FILTER_PARAMETERS* FilterParameters);
  HRESULT FINEAPI GetFilterConfig        (LONG Index, BOOL* Active, FILTER_PARAMETERS* FilterParameters);
  HRESULT FINEAPI GetFilterGUIDByIndex   (LONG Index, GUID* FilterGUID);
  HRESULT FINEAPI SetFilterOrder         (LONG Index, LONG Order);
  BOOL    FINEAPI FilterImage            (HBITMAP* Bitmap);
  HRESULT FINEAPI RemoveAllFilters       ();
  BOOL    FINEAPI GetUseMMX              ();
  HRESULT FINEAPI SetUseMMX              (BOOL UseMMX);
  BOOL    FINEAPI GetUseSSE2             ();
  HRESULT FINEAPI SetUseSSE2             (BOOL UseSSE2);