unit FineDemoExUnit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Fine;

type
  TOpenRawForm1 = class(TForm)
    Label1: TLabel;
    Width: TEdit;
    Label2: TLabel;
    Height: TEdit;
    Label3: TLabel;
    ImageFormat: TComboBox;
    Label4: TLabel;
    Expected: TEdit;
    Label5: TLabel;
    FileSize: TEdit;
    Button1: TButton;
    Button2: TButton;
    FileName: TEdit;
    procedure WidthChange(Sender: TObject);
    procedure HeightChange(Sender: TObject);
    procedure ImageFormatChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Format      : TGUID;
    ImageWidth  : Integer;
    ImageHeight : Integer;
    ImageBPP    : Integer;
  end;

var
  OpenRawForm1: TOpenRawForm1;

implementation
Uses
  FINEDemoExUnit1;
{$R *.dfm}

procedure TOpenRawForm1.WidthChange(Sender: TObject);
begin
  If TryStrToInt(Width.Text,ImageWidth) Then
     Begin
       Expected.Text := IntToStr(Form1.GetImageSize(ImageWidth,ImageHeight,ImageBPP));
     End;
  if Expected.Text=FileSize.Text Then
     Begin
       Expected.Color := clMoneyGreen;
       FileSize.Color := clMoneyGreen;
     End
  Else
     Begin
       Expected.Color := clRed;
       FileSize.Color := clInfoBk;
     End;
end;

procedure TOpenRawForm1.HeightChange(Sender: TObject);
begin
  If TryStrToInt(Height.Text,ImageHeight) Then
     Begin
       Expected.Text := IntToStr(Form1.GetImageSize(ImageWidth,ImageHeight,ImageBPP));
     End;
  if Expected.Text=FileSize.Text Then
     Begin
       Expected.Color := clMoneyGreen;
       FileSize.Color := clMoneyGreen;
     End
  Else
     Begin
       Expected.Color := clRed;
       FileSize.Color := clInfoBk;
     End;
end;

procedure TOpenRawForm1.ImageFormatChange(Sender: TObject);
begin
  Case ImageFormat.ItemIndex of
       0 : Begin Format := MEDIASUBTYPE_RGB8;   ImageBPP :=  8; End;
       1 : Begin Format := MEDIASUBTYPE_RGB565; ImageBPP := 16; End;
       2 : Begin Format := MEDIASUBTYPE_RGB555; ImageBPP := 16; End;
       3 : Begin Format := MEDIASUBTYPE_RGB24;  ImageBPP := 24; End;
       4 : Begin Format := MEDIASUBTYPE_RGB32;  ImageBPP := 32; End;
       5 : Begin Format := MEDIASUBTYPE_ARGB32; ImageBPP := 32; End;
       6 : Begin Format := MEDIASUBTYPE_UYVY;   ImageBPP := 16; End;
       7 : Begin Format := MEDIASUBTYPE_YUY2;   ImageBPP := 16; End;
       8 : Begin Format := MEDIASUBTYPE_YVYU;   ImageBPP := 16; End;
       9 : Begin Format := MEDIASUBTYPE_YV12;   ImageBPP := 12; End;
      10 : Begin Format := MEDIASUBTYPE_IYUV;   ImageBPP := 12; End;
      11 : Begin Format := MEDIASUBTYPE_NV12;   ImageBPP := 12; End;
  End;
  Expected.Text := IntToStr(Form1.GetImageSize(ImageWidth,ImageHeight,ImageBPP));
  if Expected.Text=FileSize.Text Then
     Begin
       Expected.Color := clMoneyGreen;
       FileSize.Color := clMoneyGreen;
     End
  Else
     Begin
       Expected.Color := clRed;
       FileSize.Color := clInfoBk;
     End;
end;

procedure TOpenRawForm1.FormCreate(Sender: TObject);
begin
  ImageWidth  := 0;
  ImageHeight := 0;
  ImageBPP    := 24;
end;

procedure TOpenRawForm1.Button1Click(Sender: TObject);
begin
  if (ImageWidth<>0) And (ImageHeight<>0) And (Expected.Text=FileSize.Text) Then
     Begin
       ModalResult := mrOk;
     End;
end;

procedure TOpenRawForm1.Button2Click(Sender: TObject);
begin
 ModalResult := mrCancel;
end;

end.
