using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Drawing.Imaging;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace FineGraphics
{
    public class FineGraphics
    {
        public enum QuantizationType { Nearest, 
                                       Halftone, 
                                       DitheredNearest, 
                                       DitheredHalftone, 
                                       FastDitheredNearest, 
                                       FastDitheredHalftone 
                                     };
        public enum ThreadPriority
        {
            Idle,
            Lowest,
            Lower,
            Normal,
            Higher,
            Highest,
            TimeCritical	
        };

        public enum DitheringType    { None, 
                                       Ordered, 
                                       FloydSteinberg 
                                     }
        public enum ResizeMethod     { Fast,
                                       FastLinear,
                                       Nearest,
                                       Linear,
                                       Spline,
                                       Hermite,
                                       Bell,
                                       Cosine,
                                       Cubic,
                                       Gaussian,
                                       Blackman,
                                       Hann,
                                       Hamming,
                                       Sinsh,
                                       Quadratic,
                                       QuadraticBSpline,
                                       CubicConvolution,
                                       CatmullRom,
                                       Mitchell,
                                       Lanczos,
                                       Lanczos3,
                                       Lanczos8,
                                       DirectDrawVideo,
                                       DirectDrawSystem,
                                       GDIPlus_Default,
                                       GDIPlus_LowQuality,
                                       GDIPlus_HighQuality,
                                       GDIPlus_Bilinear,
                                       GDIPlus_Bicubic,
                                       GDIPlus_NearestNeighbor,
                                       GDIPlus_HighQualityBilinear,
                                       GDIPlus_HighQualityBicubic,
                                       GDI
                                     }
  public enum RotationType           { Crop,
                                       Resize
                                     }

  public enum RotationMethod         { Fast,
                                       FastBilinear,
                                       GDIPlus_Default,
                                       GDIPlus_LowQuality,
                                       GDIPlus_HighQuality,
                                       GDIPlus_Bilinear,
                                       GDIPlus_Bicubic,
                                       GDIPlus_NearestNeighbor,
                                       GDIPlus_HighQualityBilinear,
                                       GDIPlus_HighQualityBicubic,
                                       GDI
                                     }

  public static Guid MEDIASUBTYPE_ANY        = new Guid( 0x00000000,  0x0000,  0x0000,  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
  public static Guid MEDIASUBTYPE_RGB1	     = new Guid( 0xE436EB78,  0x524F,  0x11CE,  0x9F,0x53,0x00,0x20,0xAF,0x0B,0xA7,0x70);
  public static Guid MEDIASUBTYPE_RGB4       = new Guid( 0xE436EB79,  0x524F,  0x11CE,  0x9F,0x53,0x00,0x20,0xAF,0x0B,0xA7,0x70);
  public static Guid MEDIASUBTYPE_RGB8       = new Guid( 0xE436EB7A,  0x524F,  0x11CE,  0x9F,0x53,0x00,0x20,0xAF,0x0B,0xA7,0x70);
  public static Guid MEDIASUBTYPE_RGB565     = new Guid( 0xE436EB7B,  0x524F,  0x11CE,  0x9F,0x53,0x00,0x20,0xAF,0x0B,0xA7,0x70);
  public static Guid MEDIASUBTYPE_RGB555     = new Guid( 0xE436EB7C,  0x524F,  0x11CE,  0x9F,0x53,0x00,0x20,0xAF,0x0B,0xA7,0x70);
  public static Guid MEDIASUBTYPE_RGB24      = new Guid( 0xE436EB7D,  0x524F,  0x11CE,  0x9F,0x53,0x00,0x20,0xAF,0x0B,0xA7,0x70);
  public static Guid MEDIASUBTYPE_RGB32      = new Guid( 0xE436EB7E,  0x524F,  0x11CE,  0x9F,0x53,0x00,0x20,0xAF,0x0B,0xA7,0x70);
  public static Guid MEDIASUBTYPE_ARGB32     = new Guid( 0x773c9ac0,  0x3274,  0x11d0,  0xb7,0x24,0x00,0xaa,0x00,0x6c,0x1a,0x01);
  public static Guid MEDIASUBTYPE_UYVY       = new Guid( 0x59565955,  0x0000,  0x0010,  0x80,0x00,0x00,0xAA,0x00,0x38,0x9B,0x71);
  public static Guid MEDIASUBTYPE_YUY2       = new Guid( 0x32595559,  0x0000,  0x0010,  0x80,0x00,0x00,0xAA,0x00,0x38,0x9B,0x71);
  public static Guid MEDIASUBTYPE_YVYU       = new Guid( 0x55595659,  0x0000,  0x0010,  0x80,0x00,0x00,0xAA,0x00,0x38,0x9B,0x71);
  public static Guid MEDIASUBTYPE_YV12       = new Guid( 0x32315659,  0x0000,  0x0010,  0x80,0x00,0x00,0xAA,0x00,0x38,0x9B,0x71);
  public static Guid MEDIASUBTYPE_IYUV       = new Guid( 0x56555949,  0x0000,  0x0010,  0x80,0x00,0x00,0xaa,0x00,0x38,0x9b,0x71);
  public static Guid MEDIASUBTYPE_NV12       = new Guid( 0x3231564E,  0x0000,  0x0010,  0x80,0x00,0x00,0xAA,0x00,0x38,0x9B,0x71);

  public static Guid Filter_GUID_Brightness  = new Guid( 0xF3D3B87C,  0xD34E,  0x45F3,  0x86,0xA1,0x2C,0x2C,0x8B,0x8D,0x22,0x47);
  public static Guid Filter_GUID_Contrast    = new Guid( 0xB76096C6,  0x3A9A,  0x4086,  0xA9,0xA4,0x2E,0x9F,0x6A,0xC2,0x45,0xDF);
  public static Guid Filter_GUID_Lightness   = new Guid( 0x2E6A1E18,  0x5717,  0x49FE,  0xA6,0x59,0x00,0xF1,0xB7,0x54,0x00,0x2C);
  public static Guid Filter_GUID_Darkness    = new Guid( 0x41BCDD15,  0x59BC,  0x435C,  0x90,0x4B,0xBF,0x27,0x15,0xC7,0x78,0xA6);
  public static Guid Filter_GUID_Gamma       = new Guid( 0x1E31BC62,  0x34A5,  0x491A,  0xAA,0x70,0x51,0x1A,0xA1,0x29,0xB1,0x3C);
  public static Guid Filter_GUID_Saturation  = new Guid( 0x2FDCF325,  0xE1E3,  0x4DCC,  0x8C,0xBF,0x04,0xBF,0x17,0x92,0x7D,0x79);
  public static Guid Filter_GUID_Posterize   = new Guid( 0xF3BB76E3,  0x0115,  0x4093,  0x9B,0xBB,0xD5,0x5E,0x91,0x00,0x17,0xF9);
  public static Guid Filter_GUID_Solorize    = new Guid( 0xF2176176,  0x1ED6,  0x4160,  0xB9,0x30,0x3A,0x47,0x25,0x56,0x43,0x58);
  public static Guid Filter_GUID_RemoveRed   = new Guid( 0x9B85F390,  0xED43,  0x4E2F,  0x88,0x09,0xA7,0xD1,0x68,0x20,0xBF,0x4F);
  public static Guid Filter_GUID_RemoveGreen = new Guid( 0xF8A8533C,  0x0EC8,  0x41B2,  0xA7,0x13,0x35,0x29,0x17,0xDE,0x93,0x4B);
  public static Guid Filter_GUID_RemoveBlue  = new Guid( 0xB352B2E4,  0x754A,  0x4252,  0x98,0xF0,0x78,0xA2,0x78,0xDA,0x0C,0x10);
  public static Guid Filter_GUID_AndMask     = new Guid( 0x6B30D6FD,  0x3894,  0x4DDA,  0x88,0x40,0x48,0x96,0x5A,0xA8,0x72,0xF0);
  public static Guid Filter_GUID_OrMask      = new Guid( 0xEA2AE8D9,  0x583D,  0x487F,  0xAD,0x58,0xAB,0xE8,0xEF,0x4A,0xCE,0x75);
  public static Guid Filter_GUID_XorMask     = new Guid( 0x4A696F43,  0x1E1A,  0x4AF8,  0xBC,0xF8,0x9C,0x5C,0xFB,0x0A,0xFD,0x3F);
  public static Guid Filter_GUID_Negative    = new Guid( 0xCB1C6BBD,  0xBB86,  0x4C74,  0x8E,0x45,0x92,0xC9,0x97,0xCA,0x54,0x98);
  public static Guid Filter_GUID_GrayScale   = new Guid( 0xBBA19AC4,  0xB62B,  0x466B,  0x97,0x27,0xAD,0x69,0x6F,0x71,0x1B,0x2E);
  public static Guid Filter_GUID_Sepia       = new Guid( 0xB9AACA34,  0xB61F,  0x4EFD,  0xB1,0x24,0x0C,0xA6,0xE8,0xD3,0xB9,0x1C);
  public static Guid Filter_GUID_SepiaStrong = new Guid( 0xE333C765,  0x9AED,  0x4A93,  0xB2,0x82,0x09,0x24,0xF0,0x63,0xDE,0x80);
  public static Guid Filter_GUID_Threshold   = new Guid( 0x064DE447,  0x1973,  0x4F84,  0x89,0xE4,0x72,0xBB,0x95,0x02,0xC2,0xE4);
  public static Guid Filter_GUID_SplitLight  = new Guid( 0x6F317C43,  0x1371,  0x4256,  0xBD,0x44,0x39,0x61,0xB6,0xAB,0xA9,0xED);
  public static Guid Filter_GUID_AntiAlias   = new Guid( 0xB4ABF202,  0x888C,  0x4FB9,  0x8D,0x30,0x6D,0x20,0x35,0x8E,0x51,0x95);
  public static Guid Filter_GUID_SplitBlur   = new Guid( 0x5284375A,  0xE9DE,  0x43F6,  0x83,0x95,0x34,0xC8,0x57,0xA6,0xD3,0xBD);
  public static Guid Filter_GUID_GausianBlur = new Guid( 0x95E3B1FF,  0x92E3,  0x4F94,  0x92,0x2B,0x7D,0x99,0xDC,0x89,0x45,0x49);
  public static Guid Filter_GUID_MonoNoise   = new Guid( 0xC20E7629,  0x12C3,  0x4E49,  0xB1,0xD5,0x2A,0x5E,0xA7,0xDE,0xB6,0xBF);
  public static Guid Filter_GUID_ColorNoise  = new Guid( 0x6B2AF958,  0x7EF0,  0x41B1,  0x91,0xB8,0xE0,0x79,0xF2,0xFA,0x7F,0x88);
  public static Guid Filter_GUID_Emboss      = new Guid( 0x2EE2E4BA,  0xCCEE,  0x415E,  0x9F,0x8E,0xE9,0xCA,0x62,0xC1,0x63,0xE1);
  public static Guid Filter_GUID_Pixelate    = new Guid( 0x2C35B6F2,  0x3F07,  0x426D,  0x97,0x13,0x00,0x97,0x5C,0xD7,0xB8,0x51);
  public static Guid Filter_GUID_Cell        = new Guid( 0xEFAFD33F,  0x8D6C,  0x4798,  0x9B,0xFA,0xAC,0xC3,0xA4,0x8C,0x41,0x5E);
  public static Guid Filter_GUID_Tile        = new Guid(0x1B7CC785, 0xAA78, 0x4901, 0xB6, 0x27, 0x94, 0x13, 0x31, 0x86, 0xFE, 0x3A);


        [StructLayout(LayoutKind.Sequential, Pack = 1)]
        public struct FILTER_PARAMETERS
        {
            public Int32 LParams_00;
            public Int32 LParams_01;
            public Int32 LParams_02;
            public Int32 LParams_03;
            public Int32 LParams_04;
            public Int32 LParams_05;
            public Int32 LParams_06;
            public Int32 LParams_07;
            public Int32 LParams_08;
            public Int32 LParams_09;
            public Int32 LParams_10;
            public Int32 LParams_11;
            public Int32 LParams_12;
            public Int32 LParams_13;
            public Int32 LParams_14;
            public Int32 LParams_15;
            public Int32 LParams_16;
            public Int32 LParams_17;
            public Int32 LParams_18;
            public Int32 LParams_19;
            public Int32 LParams_20;
            public Int32 LParams_21;
            public Int32 LParams_22;
            public Int32 LParams_23;
            public Int32 LParams_24;
            public Int32 LParams_25;
            public Int32 LParams_26;
            public Int32 LParams_27;
            public Int32 LParams_28;
            public Int32 LParams_29;
            public Int32 LParams_30;
            public Int32 LParams_31;
            public Int32 LParams_32;
            public Int32 LParams_33;
            public Int32 LParams_34;
            public Int32 LParams_35;
            public Int32 LParams_36;
            public Int32 LParams_37;
            public Int32 LParams_38;
            public Int32 LParams_39;
            public Int32 LParams_40;
            public Int32 LParams_41;
            public Int32 LParams_42;
            public Int32 LParams_43;
            public Int32 LParams_44;
            public Int32 LParams_45;
            public Int32 LParams_46;
            public Int32 LParams_47;
            public Int32 LParams_48;
            public Int32 LParams_49;
            public Int32 LParams_50;
            public double DParams_00;
            public double DParams_01;
            public double DParams_02;
            public double DParams_03;
            public double DParams_04;
            public double DParams_05;
            public double DParams_06;
            public double DParams_07;
            public double DParams_08;
            public double DParams_09;
            public double DParams_10;
            public double DParams_11;
            public double DParams_12;
            public double DParams_13;
            public double DParams_14;
            public double DParams_15;
            public double DParams_16;
            public double DParams_17;
            public double DParams_18;
            public double DParams_19;
            public double DParams_20;
            public double DParams_21;
            public double DParams_22;
            public double DParams_23;
            public double DParams_24;
            public double DParams_25;
            public double DParams_26;
            public double DParams_27;
            public double DParams_28;
            public double DParams_29;
            public double DParams_30;
            public double DParams_31;
            public double DParams_32;
            public double DParams_33;
            public double DParams_34;
            public double DParams_35;
            public double DParams_36;
            public double DParams_37;
            public double DParams_38;
            public double DParams_39;
            public double DParams_40;
            public double DParams_41;
            public double DParams_42;
            public double DParams_43;
            public double DParams_44;
            public double DParams_45;
            public double DParams_46;
            public double DParams_47;
            public double DParams_48;
            public double DParams_49;
            public double DParams_50;
            
        };


        [DllImport("FineGraphics.dll", EntryPoint = "PrepareCrop", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern  bool    Fine_PrepareCrop(Int32 OriginalWidth, Int32 OriginalHeight, Int32 Left, Int32 Top, Int32 Right, Int32 Bottom);

        [DllImport("FineGraphics.dll", EntryPoint = "Crop", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern  bool    Fine_Crop(ref IntPtr Bitmap);

        [DllImport("FineGraphics.dll", EntryPoint = "CropEx", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern  bool    Fine_CropEx(IntPtr SrcBitmap, ref IntPtr DstBitmap);

        [DllImport("FineGraphics.dll", EntryPoint = "DoneCrop", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern bool     Fine_DoneCrop();

        [DllImport("FineGraphics.dll", EntryPoint = "PrepareResize", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern  bool    Fine_PrepareResize(Int32 SrcWidth, Int32 SrcHeight, Rectangle SrcRect, Rectangle DstRect, Int32 ResizeMethod);

        [DllImport("FineGraphics.dll", EntryPoint = "Resize", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern  bool    Fine_Resize(ref IntPtr Bitmap);

        [DllImport("FineGraphics.dll", EntryPoint = "ResizeEx", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern  bool    Fine_ResizeEx(IntPtr SrcBitmap, ref IntPtr DstBitmap);

        [DllImport("FineGraphics.dll", EntryPoint = "DoneResize", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern  bool    Fine_DoneResize();

        [DllImport("FineGraphics.dll", EntryPoint = "FlipVertical", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern  bool    Fine_FlipVertical(ref IntPtr Bitmap);

        [DllImport("FineGraphics.dll", EntryPoint = "FlipVerticalEx", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern  bool    Fine_FlipVerticalEx(IntPtr SrcBitmap, ref IntPtr DstBitmap);

        [DllImport("FineGraphics.dll", EntryPoint = "FlipHorizontal", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern  bool    Fine_FlipHorizontal(ref IntPtr Bitmap);

        [DllImport("FineGraphics.dll", EntryPoint = "FlipHorizontalEx", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern  bool    Fine_FlipHorizontalEx(IntPtr SrcBitmap, ref IntPtr DstBitmap);

        [DllImport("FineGraphics.dll", EntryPoint = "PrepareRotate", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern  bool    Fine_PrepareRotate(Int32 ImageWidth, Int32 ImageHeight, double RotationAngle, Point RotationCenter, Int32  RotationMethod, Int32 RotationType);

        [DllImport("FineGraphics.dll", EntryPoint = "GetRotatedSize", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern  Size    Fine_GetRotatedSize();

        [DllImport("FineGraphics.dll", EntryPoint = "Rotate", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern  bool    Fine_Rotate(ref IntPtr Bitmap, UInt32 GapColor);

        [DllImport("FineGraphics.dll", EntryPoint = "RotateEx", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern  bool    Fine_RotateEx(IntPtr SrcBitmap, ref IntPtr DstBitmap, UInt32 GapColor);

        [DllImport("FineGraphics.dll", EntryPoint = "DoneRotate", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern  bool    Fine_DoneRotate();

        [DllImport("FineGraphics.dll", EntryPoint = "GetBitmapSize", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern  Int32   Fine_GetBitmapSize(Int32 ImageWidth, Int32 ImageHeight,ref Guid MediaSubtype);

        [DllImport("FineGraphics.dll", EntryPoint = "GetRawData", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern  bool    Fine_GetRawData(IntPtr Bitmap, IntPtr RawData,ref Guid MediaSubtype);

        [DllImport("FineGraphics.dll", EntryPoint = "CreateBitmap", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern  IntPtr  Fine_CreateBitmap(Int32 ImageWidth, Int32 ImageHeight,ref Guid MediaSubtype);

        [DllImport("FineGraphics.dll", EntryPoint = "ApplyPalette", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern  bool    Fine_ApplyPalette(IntPtr Bitmap, IntPtr Palette);

        [DllImport("FineGraphics.dll", EntryPoint = "LoadBitmap", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern IntPtr   Fine_LoadBitmap(IntPtr FileName, ref Guid OutputMediaSubtype, Int32 OutputQuantizationType, Int32 OutputDitherType);

        [DllImport("FineGraphics.dll", EntryPoint = "LoadRawImage", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern IntPtr   Fine_LoadRawImage(IntPtr FileName, Int32 ImageWidth, Int32 ImageHeight,ref Guid InputMediaSubtype, ref Guid OutputMediaSubtype, Int32 OutputQuantizationType, Int32 OutputDitherType);

        [DllImport("FineGraphics.dll", EntryPoint = "SaveBitmap", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern bool     Fine_SaveBitmap(IntPtr FileName, IntPtr Bitmap, ref Guid MediaSubtype);

        [DllImport("FineGraphics.dll", EntryPoint = "SaveRawImage", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern bool     Fine_SaveRawImage(IntPtr FileName, IntPtr Bitmap, ref Guid MediaSubtype);

        [DllImport("FineGraphics.dll", EntryPoint = "ConvertFromRGBToRGB", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern bool     Fine_ConvertFromRGBToRGB(IntPtr SrcBitmap, ref IntPtr DstBitmap, Int32 QuantizationType, Int32 DitherType);

        [DllImport("FineGraphics.dll", EntryPoint = "ConvertFromRGB32", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern bool     Fine_ConvertFromRGB32(IntPtr SrcImage, IntPtr DstImage, ref IntPtr DstPalette, Int32 ImageWidth, Int32 ImageHeight,ref Guid MediaSubtype, Int32 QuantizationType, Int32 DitherType);

        [DllImport("FineGraphics.dll", EntryPoint = "ConvertFromRGB32Ex", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern bool     Fine_ConvertFromRGB32Ex(IntPtr SrcBitmap, ref IntPtr DstBitmap, ref Guid MediaSubtype, Int32 QuantizationType, Int32 DitherType);

        [DllImport("FineGraphics.dll", EntryPoint = "ConvertToRGB32", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern bool     Fine_ConvertToRGB32(IntPtr SrcImage, IntPtr DstImage, IntPtr SrcPalette, Int32 ImageWidth, Int32 ImageHeight, ref Guid MediaSubtype);

        [DllImport("FineGraphics.dll", EntryPoint = "ConvertToRGB32Ex", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern bool     Fine_ConvertToRGB32Ex(IntPtr SrcBitmap, ref IntPtr DstBitmap, ref Guid MediaSubtype);

        [DllImport("FineGraphics.dll", EntryPoint = "AddFilter", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern Int32    Fine_AddFilter(ref Guid FilterGUID, ref FILTER_PARAMETERS FilterParameters, ref Int32 Index);

        [DllImport("FineGraphics.dll", EntryPoint = "GetFilterDefaultConfig", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern Int32    Fine_GetFilterDefaultConfig(ref Guid FilterGUID, ref FILTER_PARAMETERS  FilterParameters);

        [DllImport("FineGraphics.dll", EntryPoint = "ConfigFilter", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern Int32    Fine_ConfigFilter(Int32 Index, bool Active, ref FILTER_PARAMETERS  FilterParameters);

        [DllImport("FineGraphics.dll", EntryPoint = "GetFilterConfig", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern Int32    Fine_GetFilterConfig(Int32 Index, ref bool Active, ref FILTER_PARAMETERS  FilterParameters);

        [DllImport("FineGraphics.dll", EntryPoint = "GetFilterGUIDByIndex", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern Int32    Fine_GetFilterGUIDByIndex(Int32 Index, ref Guid FilterGUID);

        [DllImport("FineGraphics.dll", EntryPoint = "SetFilterOrder", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern Int32    Fine_SetFilterOrder (Int32 Index, Int32 Order);

        [DllImport("FineGraphics.dll", EntryPoint = "FilterImage", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern bool     Fine_FilterImage(ref IntPtr Bitmap);

        [DllImport("FineGraphics.dll", EntryPoint = "RemoveAllFilters", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern Int32 Fine_RemoveAllFilters();

        [DllImport("FineGraphics.dll", EntryPoint = "GetUseMMX", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern bool Fine_GetUseMMX();

        [DllImport("FineGraphics.dll", EntryPoint = "GetUseSSE2", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern bool Fine_GetUseSSE2();

        [DllImport("FineGraphics.dll", EntryPoint = "GetUseMMX", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern Int32 Fine_SetUseMMX(bool UseMMX);

        [DllImport("FineGraphics.dll", EntryPoint = "GetUseSSE2", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern Int32 Fine_SetUseSSE2(bool UseSSe2);

        [DllImport("FineGraphics.dll", EntryPoint = "GetUseMulticore", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern Int32 Fine_GetUseMultiCore(ref bool UseMulticore,  ref bool ControlProcessors,  ref Int32 ThreadsPerProcessor, ref Int32 ThreadPriority, ref bool UseWaitState);

        [DllImport("FineGraphics.dll", EntryPoint = "SetUseMulticore", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = false, CallingConvention = CallingConvention.StdCall)]
        private static extern Int32 Fine_SetUseMultiCore(bool UseMulticore, bool ControlProcessors, Int32 ThreadsPerProcessor, Int32 ThreadPriority, bool UseWaitState);

        [System.Runtime.InteropServices.DllImport("gdi32.dll")]
        private static extern bool DeleteObject(IntPtr hObject);

        //********************************************************************************************************************************
        public static int GetBitmapSize(int Width, int Height, Guid MediaSubtype)
        {
            return Fine_GetBitmapSize((Int32)Width, (Int32)Height, ref MediaSubtype);
        }

        public static Boolean PrepareCrop(int OriginalWidth, int OriginalHeight, Rectangle Crop)
        {
            return (Boolean)Fine_PrepareCrop(OriginalWidth, OriginalHeight, Crop.Left, Crop.Top, Crop.Right, Crop.Bottom);
        }

        public static Boolean Crop(ref Bitmap Bmp)
        {
            IntPtr HBitmap;
            Boolean Result;
            //**************************************
            HBitmap = Bmp.GetHbitmap();
            Result = (Boolean)Fine_Crop(ref HBitmap);
            if (Result)
            {
                Bmp.Dispose();
                Bmp = Bitmap.FromHbitmap(HBitmap);
            }
            DeleteObject(HBitmap);
            //**************************************
            return Result;
        }

        public static Boolean DoneCrop()
        {
            return (Boolean)Fine_DoneCrop();
        }

        public static Boolean PrepareResize(int OriginalWidth, int OriginalHeight, Rectangle SrcRect, Rectangle DstRect, ResizeMethod Method)
        {
            Boolean Result;
            Result = (Boolean)Fine_PrepareResize((Int32)OriginalWidth, (Int32)OriginalHeight, SrcRect, DstRect, (Int32)Method);
            return Result;
        }

        public static Size GetRotatedSize()
        {
        return Fine_GetRotatedSize();
        }

        public static Boolean Resize(ref Bitmap Bmp)
        {
            IntPtr HBitmap;
            Boolean Result;
            //**************************************
            HBitmap = Bmp.GetHbitmap();
            Result = (Boolean)Fine_Resize(ref HBitmap);
            if (Result)
            {
                Bmp.Dispose();
                Bmp = Bitmap.FromHbitmap(HBitmap);
            }
            DeleteObject(HBitmap);
            //**************************************
            return Result;
        }

        public static Boolean DoneResize()
        {
            return (Boolean)Fine_DoneResize();
        }

        public static Boolean FlipHorizontal(ref Bitmap Bmp)
        {
            IntPtr  HBitmap;
            Boolean Result;
            //**************************************
            HBitmap = Bmp.GetHbitmap();
            Result = (Boolean)Fine_FlipHorizontal(ref HBitmap);
            if (Result)
            {
                Bmp.Dispose();
                Bmp = Bitmap.FromHbitmap(HBitmap);
            }
            DeleteObject(HBitmap);
            //**************************************
            return Result;
        }

        public static Boolean FlipVertical(ref Bitmap Bmp)
        {
            IntPtr HBitmap;
            Boolean Result;
            //**************************************
            HBitmap = Bmp.GetHbitmap();
            try
            {
            Result = Fine_FlipVertical(ref HBitmap);
            }
            catch
            {
                Result = false;
            }
            if (Result)
            {
                Bmp.Dispose();
                Bmp = Bitmap.FromHbitmap(HBitmap);
            }
            DeleteObject(HBitmap);
            //**************************************
            return Result;
        }

        public static Boolean PrepareRotate(int OrigilalWidth, int OrigilalHeight, double Angle, Point Center, RotationMethod Method, RotationType Type)
        {
            Boolean Result;
            Result = (Boolean)Fine_PrepareRotate((Int32)OrigilalWidth, (Int32)OrigilalHeight, Angle, Center, (Int32)Method, (Int32)Type);
            return Result;
        }

        public static Boolean Rotate(ref Bitmap Bmp, Color GapColor)
        {
            IntPtr HBitmap;
            Boolean Result;
            UInt32 Gap;
            //**************************************
            HBitmap = Bmp.GetHbitmap();
            Gap = (UInt32)GapColor.ToArgb();
            Result = (Boolean)Fine_Rotate(ref HBitmap, Gap);
            if (Result)
            {
                Bmp.Dispose();
                Bmp = Bitmap.FromHbitmap(HBitmap);
            }
            DeleteObject(HBitmap);
            //**************************************
            return Result;
        }

        public static Boolean DoneRotate()
        {
            return (Boolean)Fine_DoneRotate();
        }

        private static Boolean GetRawData(Bitmap Bmp, IntPtr RawData, Guid MediaSubtype)
        {
          IntPtr HBitmap;
          Boolean Result;
          //**************************************
          HBitmap = Bmp.GetHbitmap();
          Result = Fine_GetRawData(HBitmap, RawData, ref MediaSubtype);
          DeleteObject(HBitmap);
          //**************************************
          return Result;          
        }

        public static Bitmap CreateBitmap(int Width, int Height, Guid MediaSubType)
        {
            Bitmap Result;
            IntPtr HBitmap;
            //**************************************
            HBitmap = Fine_CreateBitmap((Int32)Width, (Int32)Height, ref MediaSubType);
            Result = Bitmap.FromHbitmap(HBitmap);
            DeleteObject(HBitmap);
            //**************************************
            return Result;
        }

        public static Boolean ApplyPalette(Bitmap Bmp, ColorPalette Pal)
        {
            IntPtr HBitmap;
            IntPtr HPalette;
            Boolean Result;
            //**************************************
            HBitmap = Bmp.GetHbitmap();
            HPalette = IntPtr.Zero;           
            Result = Fine_ApplyPalette(HBitmap,HPalette);
            DeleteObject(HPalette);
            DeleteObject(HBitmap);
            //**************************************
            return Result;          
        }

        public static Bitmap LoadBitmap(String FileName, Guid MediaSubType, QuantizationType Quantization, DitheringType Dithering)
        {
          Bitmap Result;
          IntPtr HBitmap;
          //**************************************
          HBitmap = Fine_LoadBitmap(Marshal.StringToHGlobalUni(FileName), ref MediaSubType, (Int32)Quantization, (Int32)Dithering);
          Result  = Bitmap.FromHbitmap(HBitmap);
          DeleteObject(HBitmap);
          //**************************************
          return Result;
        }

        public static Bitmap LoadRawImage(String FileName, int Width, int Height, Guid InputMediaSubType, Guid OutputMediaSubType, QuantizationType OutputQuantizationType, DitheringType OutputDitheringType)
        {
            Bitmap Result;
            IntPtr HBitmap;
            //**************************************
            HBitmap = Fine_LoadRawImage(Marshal.StringToHGlobalUni(FileName), (Int32)Width, (Int32)Height, ref InputMediaSubType, ref OutputMediaSubType, (Int32)OutputQuantizationType, (Int32)OutputDitheringType);
            Result = Bitmap.FromHbitmap(HBitmap);
            DeleteObject(HBitmap);
            //**************************************
            return Result;
        }

        public static Boolean SaveBitmap(String FileName, Bitmap Bmp, Guid MediaSubType)
        {
            IntPtr  HBitmap;
            Boolean Result;
            //**************************************
            HBitmap = Bmp.GetHbitmap();
            Result = (Boolean)Fine_SaveBitmap(Marshal.StringToHGlobalUni(FileName), HBitmap, ref MediaSubType);
            DeleteObject(HBitmap);
            return Result;
            //**************************************
        }

        public static Boolean SaveRawImage(String FileName, Bitmap Bmp, Guid MediaSubType)
        {
            IntPtr HBitmap;
            Boolean Result;
            //**************************************
            HBitmap = Bmp.GetHbitmap();
            Result = (Boolean)Fine_SaveRawImage(Marshal.StringToHGlobalUni(FileName), HBitmap, ref MediaSubType);
            DeleteObject(HBitmap);
            return Result;
            //**************************************
        }

        public static int AddFilter(Guid FilterGUID, FILTER_PARAMETERS FilterParameters, ref int Index)
        {
            return (int)Fine_AddFilter(ref FilterGUID, ref FilterParameters, ref (Int32)Index);
        }

        public static int GetFilterDefaultConfig(Guid FilterGUID, ref FILTER_PARAMETERS FilterParameters)
        {
            return (int)Fine_GetFilterDefaultConfig(ref FilterGUID, ref FilterParameters);
        }
        
        public static int ConfigFilter(int Index, Boolean Active, ref FILTER_PARAMETERS FilterParameters)
        {
            return (int)Fine_ConfigFilter((Int32)Index, (bool)Active, ref FilterParameters);
        }

        public static int GetFilterConfig(int Index, ref Boolean Active, ref FILTER_PARAMETERS FilterParameters)
        {
            return (int)Fine_GetFilterConfig((Int32)Index, ref (bool)Active, ref FilterParameters);
        }

        public static int GetFilterGUIDByIndex(int Index, ref Guid FilterGUID)
        {
            return (int)Fine_GetFilterGUIDByIndex((Int32)Index, ref FilterGUID);
        }

        public static int SetFilterOrder(int Index, int Order)
        {
            return (int)Fine_SetFilterOrder((Int32)Index, (Int32)Order);
        }

        public static Boolean FilterImage(ref Bitmap Bmp)        
        {
            IntPtr HBitmap;
            Boolean Result;
            //**************************************
            HBitmap = Bmp.GetHbitmap();
            Result = (Boolean)Fine_FilterImage(ref HBitmap);
            if (Result)
            {
                Bmp.Dispose();
                Bmp = Bitmap.FromHbitmap(HBitmap);
            }
            DeleteObject(HBitmap);
            //**************************************
            return Result;      
        }

        public static int RemoveAllFilters()
        {
            return (int)Fine_RemoveAllFilters();        
        }

        public static Boolean ConvertFromRGBToRGB(Bitmap SrcBitmap, ref Bitmap DstBitmap, QuantizationType Quantization, DitheringType Dithering)
        {
            IntPtr SrcHBitmap;
            IntPtr DstHBitmap;
            Boolean Result;
            //**************************************
            SrcHBitmap = SrcBitmap.GetHbitmap();
            DstHBitmap = DstBitmap.GetHbitmap();
            Result = (Boolean)Fine_ConvertFromRGBToRGB(SrcHBitmap, ref DstHBitmap, (Int32) Quantization, (Int32) Dithering);
            if (Result)
            {
                DstBitmap.Dispose();
                DstBitmap = Bitmap.FromHbitmap(DstHBitmap);
            }
            DeleteObject(SrcHBitmap);
            DeleteObject(DstHBitmap);
            //**************************************
            return Result; 
        }
        
        public static Boolean ConvertFromRGB32Ex(Bitmap SrcBitmap, ref Bitmap DstBitmap, Guid MediaSubtype, QuantizationType Quantization, DitheringType Dithering)
        {
            IntPtr SrcHBitmap;
            IntPtr DstHBitmap;
            Boolean Result;
            //**************************************
            Result = false;
            DstBitmap.Dispose();
            SrcHBitmap = SrcBitmap.GetHbitmap();
            DstHBitmap = Fine_CreateBitmap(SrcBitmap.Width, SrcBitmap.Height, ref MediaSubtype);
            Result = (Boolean)Fine_ConvertFromRGB32Ex(SrcHBitmap, ref DstHBitmap, ref MediaSubtype, (Int32)Quantization, (Int32)Dithering);
            if (Result)
            {
                DstBitmap.Dispose();
                DstBitmap = Bitmap.FromHbitmap(DstHBitmap);
            }
            DeleteObject(SrcHBitmap);
            DeleteObject(DstHBitmap);
            //**************************************            
            return Result; 
        }

        public static Boolean ConvertToRGB32Ex(Bitmap SrcBitmap, ref Bitmap DstBitmap, Guid MediaSubtype)
        {
            IntPtr SrcHBitmap;
            IntPtr DstHBitmap;
            Boolean Result;
            //**************************************
            SrcHBitmap = SrcBitmap.GetHbitmap();
            DstHBitmap = DstBitmap.GetHbitmap();
            Result = (Boolean)Fine_ConvertToRGB32Ex(SrcHBitmap, ref DstHBitmap, ref MediaSubtype);
            if (Result)
            {
                DstBitmap.Dispose();
                DstBitmap = Bitmap.FromHbitmap(DstHBitmap);
            }
            DeleteObject(SrcHBitmap);
            DeleteObject(DstHBitmap);
            //**************************************
            return Result;
        }

        public static Boolean GetUseMMX()
        {
            return (Boolean)Fine_GetUseMMX();
        }

        public static Boolean GetUseSSE2()
        {
            return (Boolean)Fine_GetUseSSE2();
        }

        public static int SetUseMMX(Boolean UseMMX)
        {
            return (int)Fine_SetUseMMX((bool)UseMMX);
        }

        public static int SetUseSSE2(Boolean UseSSE2)
        {
            return (int)Fine_SetUseSSE2((bool)UseSSE2);
        }

        public static int GetUseMultiCore(ref Boolean UseMulticore, ref Boolean ControlProcessors, ref int ThreadsPerProcessor, ref ThreadPriority Priority, ref Boolean UseWaitState)
        {
            int Result;
            Int32 PriorityOfThread;
            PriorityOfThread = 0;
            Result           = (int)Fine_GetUseMultiCore(ref (bool)UseMulticore, ref (bool)ControlProcessors, ref (Int32)ThreadsPerProcessor, ref (Int32)PriorityOfThread, ref (bool)UseWaitState);
            Priority         = (ThreadPriority)PriorityOfThread;
            return Result; 
        }

        public static int SetUseMultiCore(Boolean UseMulticore, Boolean ControlProcessors, int ThreadsPerProcessor, ThreadPriority Priority, Boolean UseWaitState)
        {
            return (int)Fine_SetUseMultiCore((bool)UseMulticore, (bool)ControlProcessors, (Int32)ThreadsPerProcessor, (Int32)Priority, (bool)UseWaitState);            
        }
    }
}
