using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using FineGraphics;





namespace Fine_CSharp
{
    
       
    public partial class Form1 : Form
    {
        Bitmap  Bmp;
        Bitmap  TempBmp;
        Boolean BitmapLoaded;
        int FilterIndex;

        public Form1()
        {
            InitializeComponent();
            Bmp = new Bitmap(10,10);
            TempBmp = new Bitmap(10, 10);
        }
               
        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {                
                Bmp.Dispose();                
                Bmp = FineGraphics.FineGraphics.LoadBitmap(openFileDialog1.FileName, FineGraphics.FineGraphics.MEDIASUBTYPE_RGB32, FineGraphics.FineGraphics.QuantizationType.FastDitheredNearest, FineGraphics.FineGraphics.DitheringType.None);
                TempBmp = (Bitmap)Bmp.Clone();
                pictureBox1.Image = Bmp;
                BitmapLoaded = true;
                if (checkBox1.Checked) checkBox1_CheckedChanged(checkBox1,null);
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (BitmapLoaded)
            {                
                if (FineGraphics.FineGraphics.PrepareCrop(TempBmp.Width, TempBmp.Height, new Rectangle(100, 100, 100, 100)))
                {
                    FineGraphics.FineGraphics.Crop(ref TempBmp);
                    pictureBox1.Image = TempBmp;
                    FineGraphics.FineGraphics.DoneCrop();
                    if (checkBox1.Checked) checkBox1_CheckedChanged(checkBox1, null);
                }
            }
        }

        private void button6_Click(object sender, EventArgs e)
        {
            if (BitmapLoaded)
            {                
                if (FineGraphics.FineGraphics.PrepareRotate(TempBmp.Width, TempBmp.Height, 45, new Point(Bmp.Width / 2, Bmp.Height / 2), FineGraphics.FineGraphics.RotationMethod.FastBilinear, FineGraphics.FineGraphics.RotationType.Resize))
                {
                    if (FineGraphics.FineGraphics.Rotate(ref TempBmp, Color.Black))
                    {
                        pictureBox1.Image = TempBmp;
                        FineGraphics.FineGraphics.DoneRotate();
                        if (checkBox1.Checked) checkBox1_CheckedChanged(checkBox1, null);
                    }
                }
            }
        }

        private void FlipVButton_Click(object sender, EventArgs e)
        {
            if (BitmapLoaded)
            {                
                if (FineGraphics.FineGraphics.FlipVertical(ref TempBmp))
                {
                    pictureBox1.Image = TempBmp;
                    if (checkBox1.Checked) checkBox1_CheckedChanged(checkBox1, null);
                }
            }
        }

        private void FlipHbutton_Click(object sender, EventArgs e)
        {
            if (BitmapLoaded)
            {
                if (FineGraphics.FineGraphics.FlipHorizontal(ref TempBmp))
                {
                    pictureBox1.Image = TempBmp;
                    if (checkBox1.Checked) checkBox1_CheckedChanged(checkBox1, null);
                }
            }
        }

        private void RevertButton_Click(object sender, EventArgs e)
        {
            if (BitmapLoaded)
            {
                TempBmp = (Bitmap)Bmp.Clone();
                pictureBox1.Image = TempBmp;
            }
            if (checkBox1.Checked) checkBox1_CheckedChanged(checkBox1, null);
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            int NewWidth;
            int NewHeight;
            double Ratio;
            double RatioW;
            double RatioH;
            Bitmap Tmp;
            if (BitmapLoaded)
            {                
                if (checkBox1.Checked)
                {
                    Tmp = (Bitmap)TempBmp.Clone();
                    Ratio = (double)((double)TempBmp.Width / (double)TempBmp.Height);
                    RatioW = (double)((double)pictureBox1.Width / (double)TempBmp.Width);
                    RatioH = (double)((double)pictureBox1.Height / (double)TempBmp.Height);
                    if (RatioW > RatioH)
                    {
                        NewHeight = (int)(TempBmp.Height * RatioH);
                        NewWidth = (int)(NewHeight * Ratio);
                    }
                    else
                    {
                        NewWidth = (int)(TempBmp.Width * RatioW);
                        NewHeight = (int)(NewWidth / Ratio);
                    }

                    if (FineGraphics.FineGraphics.PrepareResize(TempBmp.Width, TempBmp.Height, new Rectangle(0, 0, TempBmp.Width, TempBmp.Height), new Rectangle(0, 0, NewWidth, NewHeight), FineGraphics.FineGraphics.ResizeMethod.Cubic))
                    {
                        if (FineGraphics.FineGraphics.Resize(ref Tmp))
                        {
                            pictureBox1.Image = Tmp;
                        }
                        FineGraphics.FineGraphics.DoneResize();                        
                    }
                }
                else
                {
                    pictureBox1.Image = TempBmp;                    
                }
            }
        }

        private void pictureBox1_ClientSizeChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked) checkBox1_CheckedChanged(checkBox1, null);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            FineGraphics.FineGraphics.FILTER_PARAMETERS Params;
            Params= new FineGraphics.FineGraphics.FILTER_PARAMETERS();
            if (BitmapLoaded)
            {
               if (FineGraphics.FineGraphics.RemoveAllFilters()==0)
                  {                    
                   if (FineGraphics.FineGraphics.GetFilterDefaultConfig(FineGraphics.FineGraphics.Filter_GUID_GrayScale,ref Params)==0)
                       {
                           if (FineGraphics.FineGraphics.AddFilter(FineGraphics.FineGraphics.Filter_GUID_GrayScale, Params, ref FilterIndex) == 0)
                           {
                               if (FineGraphics.FineGraphics.ConfigFilter(FilterIndex, true, ref Params) == 0)
                               {
                                   if (FineGraphics.FineGraphics.FilterImage(ref TempBmp))
                                   {                                       
                                       pictureBox1.Image = TempBmp;
                                       if (checkBox1.Checked) checkBox1_CheckedChanged(checkBox1, null);
                                   }
                               }
                           }
                      }
                  }
            }

        }

        private void button2_Click_1(object sender, EventArgs e)
        {
            Bitmap BmpRGB8;
            if (BitmapLoaded)
            {
                BmpRGB8 = new Bitmap(TempBmp.Width, TempBmp.Height, System.Drawing.Imaging.PixelFormat.Format8bppIndexed);
                if (FineGraphics.FineGraphics.ConvertFromRGB32Ex(TempBmp, ref BmpRGB8,FineGraphics.FineGraphics.MEDIASUBTYPE_RGB8, FineGraphics.FineGraphics.QuantizationType.DitheredNearest, FineGraphics.FineGraphics.DitheringType.None))
                {
                    TempBmp.Dispose();
                    TempBmp=(Bitmap)BmpRGB8.Clone();
                    BmpRGB8.Dispose();
                    pictureBox1.Image = TempBmp;
                    if (checkBox1.Checked) checkBox1_CheckedChanged(checkBox1, null);
                }
            }

        }

        private void checkBox2_CheckedChanged(object sender, EventArgs e)
        {
            if (FineGraphics.FineGraphics.SetUseMMX(UseMMX.Checked) == 0)
            {
            }
        }

        private void UseSSE2_CheckedChanged(object sender, EventArgs e)
        {
            if (FineGraphics.FineGraphics.SetUseSSE2(UseSSE2.Checked) == 0)
            {
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Boolean                                  Multicore           = false;
            Boolean                                  ControlProcessors   = false;
            int                                      TPProcessor         = 0;
            FineGraphics.FineGraphics.ThreadPriority Priority            = FineGraphics.FineGraphics.ThreadPriority.Idle;
            Boolean                                  UseWaitState        = false;
            FineGraphics.FineGraphics.GetUseMultiCore(ref Multicore, ref ControlProcessors, ref TPProcessor, ref Priority, ref UseWaitState);
            UseMulticore.Checked                                         = Multicore;
            ControlTheProcessors.Checked                                 = ControlProcessors;
            WaitState.Checked                                            = UseWaitState;
            ThreadsPerProcessor.SelectedIndex                            = ThreadsPerProcessor.Items.IndexOf(TPProcessor.ToString());
            ThreadPriority.SelectedIndex                                 = (int)Priority;
            UseMMX.Checked                                               = FineGraphics.FineGraphics.GetUseMMX();
            UseSSE2.Checked                                              = FineGraphics.FineGraphics.GetUseSSE2();
        }

        private void checkBox2_CheckedChanged_1(object sender, EventArgs e)
        {
            Boolean Multicore         = false;
            Boolean ControlProcessors = false;
            int     TPProcessor       = -1;
            FineGraphics.FineGraphics.ThreadPriority Priority = FineGraphics.FineGraphics.ThreadPriority.Idle;
            Boolean UseWaitState      = false;
            FineGraphics.FineGraphics.GetUseMultiCore(ref Multicore, ref ControlProcessors, ref TPProcessor, ref Priority, ref UseWaitState);
            Multicore                 = UseMulticore.Checked;
            FineGraphics.FineGraphics.SetUseMultiCore(Multicore,ControlProcessors,TPProcessor,Priority, UseWaitState);    
        }

        private void ThreadsPerProcessor_SelectedIndexChanged(object sender, EventArgs e)
        {
            Boolean Multicore         = false;
            Boolean ControlProcessors = false;
            int TPProcessor           = -1;
            FineGraphics.FineGraphics.ThreadPriority Priority = FineGraphics.FineGraphics.ThreadPriority.Idle;
            Boolean      UseWaitState = false;
            FineGraphics.FineGraphics.GetUseMultiCore(ref Multicore, ref ControlProcessors, ref TPProcessor, ref Priority, ref UseWaitState);
            TPProcessor               = ThreadsPerProcessor.SelectedIndex + 1;
            FineGraphics.FineGraphics.SetUseMultiCore(Multicore, ControlProcessors, TPProcessor, Priority, UseWaitState);    

        }

        private void ControlTheProcessors_CheckedChanged(object sender, EventArgs e)
        {
            Boolean Multicore         = false;
            Boolean ControlProcessors = false;
            int TPProcessor           = -1;
            FineGraphics.FineGraphics.ThreadPriority Priority = FineGraphics.FineGraphics.ThreadPriority.Idle;
            Boolean      UseWaitState = false;
            FineGraphics.FineGraphics.GetUseMultiCore(ref Multicore, ref ControlProcessors, ref TPProcessor, ref Priority, ref UseWaitState);
            ControlProcessors         = ControlTheProcessors.Checked;
            FineGraphics.FineGraphics.SetUseMultiCore(Multicore, ControlProcessors, TPProcessor, Priority, UseWaitState);    
        }

        private void WaitState_CheckedChanged(object sender, EventArgs e)
        {
            Boolean Multicore         = false;
            Boolean ControlProcessors = false;
            int TPProcessor           = -1;
            FineGraphics.FineGraphics.ThreadPriority Priority = FineGraphics.FineGraphics.ThreadPriority.Idle;
            Boolean UseWaitState      = false;
            FineGraphics.FineGraphics.GetUseMultiCore(ref Multicore, ref ControlProcessors, ref TPProcessor, ref Priority, ref UseWaitState);
            UseWaitState              = WaitState.Checked;
            FineGraphics.FineGraphics.SetUseMultiCore(Multicore, ControlProcessors, TPProcessor, Priority, UseWaitState);    
        }

        private void Priority_SelectedIndexChanged(object sender, EventArgs e)
        {
            Boolean Multicore = false;
            Boolean ControlProcessors = false;
            int TPProcessor = -1;
            FineGraphics.FineGraphics.ThreadPriority Priority = FineGraphics.FineGraphics.ThreadPriority.Idle;
            Boolean UseWaitState = false;
            FineGraphics.FineGraphics.GetUseMultiCore(ref Multicore, ref ControlProcessors, ref TPProcessor, ref Priority, ref UseWaitState);
            Priority = (FineGraphics.FineGraphics.ThreadPriority)ThreadPriority.SelectedIndex;           
            FineGraphics.FineGraphics.SetUseMultiCore(Multicore, ControlProcessors, TPProcessor, Priority, UseWaitState);    
        }

        

        

        
    }
}